﻿using System;
using Leadtools.Multimedia;
using LMVMtnDetLib;


namespace MotionDetectionWithDVR
{
   public class MtnDtCallback : ILMVMtnDetUserCallback
   {
      public MainForm theForm;      
      private ConvertCtrl convertctrl1 = new ConvertCtrl();
      
      public int CallbackProc(int lEvent, int pFrame, int lWidth, int lHeight, int lBitCount, int lFrameSize, bool bTopDown)
      {
         try
         {
            if (lEvent == (int)LMVMtnDetLib.FrameTypeConstants.FRAME_TYPE_STARTMOTION) //this is the first frame in which motion has been detected
            {
               try
               {
                  convertctrl1.TargetFormat = TargetFormatType.ISO;
                  convertctrl1.VideoCompressors.H264.Selected = true;
                  convertctrl1.SourceFile = theForm.DVRfilePath;
                  convertctrl1.TargetFile = @"Videos\"+DateTime.Now.ToString("yyyy-MM-dd-HH-mm-ss") + ".mp4";
                  if (convertctrl1.State == ConvertState.Stopped)
                  {
                     Console.WriteLine("the duration is:" + convertctrl1.Duration.ToString());
                     if (theForm.captureCtrl1.CaptureTime >= 1.5)
                        convertctrl1.SelectionStart = theForm.captureCtrl1.CaptureTime - 1.5;
                     else
                        convertctrl1.SelectionStart = theForm.captureCtrl1.CaptureTime;
                     convertctrl1.StartConvert();
                  }
               }
               catch (Exception ex)
               {
                  Console.WriteLine(ex.Message);
               }               
            }
            if (lEvent == (int)LMVMtnDetLib.FrameTypeConstants.FRAME_TYPE_STARTSTILL)  //the motion has just stopped
            {
               if (convertctrl1.State == ConvertState.Running)
               {                  
                  convertctrl1.StopConvert();
               }
            }
         }
         catch (Exception ex)
         {
            Console.WriteLine(ex.Message);
         }
         return (int)MtnCalBkErrConstants.MTNCALBK_ERR_SUCCESS;
      }
   }   
}
